#ident "%W% %G%"
 
/**************************************************************************
# Copyright (C) 1994 Kubota Graphics Corp.
# 
# Permission to use, copy, modify, and distribute this material for
# any purpose and without fee is hereby granted, provided that the
# above copyright notice and this permission notice appear in all
# copies, and that the name of Kubota Graphics not be used in
# advertising or publicity pertaining to this material.  Kubota
# Graphics Corporation MAKES NO REPRESENTATIONS ABOUT THE ACCURACY
# OR SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED
# "AS IS", WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE AND KUBOTA GRAPHICS CORPORATION DISCLAIMS ALL WARRANTIES,
# EXPRESS OR IMPLIED.
**************************************************************************/
 
/*
  ======================================================================
  Functions:
	int dor_glbrndmaxobjs_initialize ()
	dot_object * dor_glbrndmaxobjs_create (glbrndmaxobjs)
	int dor_glbrndmaxobjs_print (object)
	int dor_glbrndmaxobjs_execute (object)

  ======================================================================
 */
#include <internal/dogen.h>
#include <internal/glbatt.h>
#include <internal/studio.h>

/*
 ======================================================================
 */

DtInt doe_glbrndmaxobjs_class_id;

static DtMethodEntry glbrndmaxobjs_methods[] = {
    { DcMethodPrint,           (DtMethodPtr) dor_glbrndmaxobjs_print },
    { DcMethodStdRenderStudio, (DtMethodPtr) dor_glbrndmaxobjs_execute },
};

void dor_glbrndmaxobjs_initialize (void)
{
    doe_glbrndmaxobjs_class_id = dor_class_install (DcTypeGlbRndMaxObjs, 
		"DoGlbRendMaxObjs", 2, glbrndmaxobjs_methods,DcNullPtr);
}
/*
 ======================================================================
 */

dot_object *dor_glbrndmaxobjs_create (DtInt glbrndmaxobjs)
{
    static DtFlag initialized = DcFalse;
    dot_object *glbrndmaxobjsobject;

    if (!initialized) {
	dor_glbrndmaxobjs_initialize();
	initialized = DcTrue;
    }

    glbrndmaxobjsobject = dor_object_create(doe_glbrndmaxobjs_class_id,
					    (DtPtr)glbrndmaxobjs);

    return(glbrndmaxobjsobject);
}
/*
 ======================================================================
 */

void dor_glbrndmaxobjs_print (dot_object *object)
{
    sprintf (dor_print_get_line(),"value = %lx", object->data);
    dor_print_output(dor_print_get_line());
}
/*
 ======================================================================
 */

void dor_glbrndmaxobjs_execute (dot_object *object)
{
    if (!dor_condex_query_execute(doe_glbrndmaxobjs_class_id))
	    return;

    dor_global_glbrndmaxobjs_set_value((DtInt)(object->data));
}
